From dc2226ba73db89bc3b404808c416d2fc83e8d4d2 Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Tue, 1 Apr 2014 13:27:52 -0400
Subject: [PATCH] Fixed pagination controls.

The pagination controls have been fixed to resemble the UXD design.
The page jump control is now located between the first/previous
buttons and the next/last buttons.

Ticket #848
---
 base/server/share/webapps/pki/css/pki-ui.css             | 15 ++++++++++-----
 base/tps-tomcat/shared/webapps/tps/ui/activities.html    | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/authenticator.html | 16 +++++++++-------
 .../tps-tomcat/shared/webapps/tps/ui/authenticators.html | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/certs.html         | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/connection.html    | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/connections.html   | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/groups.html        | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/profile.html       | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/profiles.html      | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/selftests.html     | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/tokens.html        | 16 +++++++++-------
 base/tps-tomcat/shared/webapps/tps/ui/users.html         | 16 +++++++++-------
 13 files changed, 118 insertions(+), 89 deletions(-)

diff --git a/base/server/share/webapps/pki/css/pki-ui.css b/base/server/share/webapps/pki/css/pki-ui.css
index 3743c0c875f147ca3c37cef76f6af4c41cd07aa7..042f6033da61aef76fd67b092931c078fa5e50ae 100644
--- a/base/server/share/webapps/pki/css/pki-ui.css
+++ b/base/server/share/webapps/pki/css/pki-ui.css
@@ -155,19 +155,24 @@ table tfoot tr th {
   float: right;
 }
 
-.pki-table-actions span[name="info"] {
+.pki-table-actions .pki-table-info {
   line-height: 26px;
   margin: 4px;
   display: inline-block;
+  float: left;
 }
 
-table span[name="page-controls"] {
+.pki-table-actions .pki-page-controls {
   float: right;
 }
 
-table span[name="page-jump"] {
-  margin: 0 8px 0 0;
-  float: right;
+.pki-table-actions .pki-page-controls .pagination {
+  float: left;
+}
+
+.pki-table-actions .pki-page-controls .pki-page-jump {
+  margin: 0 10px 0 10px;
+  float: left;
 }
 
 #content {
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/activities.html b/base/tps-tomcat/shared/webapps/tps/ui/activities.html
index 244755f02c1ca6ba49e1c330c0631e39ced7bafe..3074a555fb8260645270663d1d63feb90043d9ed 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/activities.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/activities.html
@@ -56,20 +56,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="8">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/authenticator.html b/base/tps-tomcat/shared/webapps/tps/ui/authenticator.html
index b1cb3792d4613aa51f73f51c3f472090da145732..c5be7dfd939dc718f8d69c32cc7524c6b31dfcdf 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/authenticator.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/authenticator.html
@@ -77,20 +77,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="3">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/authenticators.html b/base/tps-tomcat/shared/webapps/tps/ui/authenticators.html
index 318aa4a10f95c22bc927b9a53c45034e829f9757..1d8311779a0bbcbea38051a31ccd02b119eada32 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/authenticators.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/authenticators.html
@@ -48,20 +48,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="3">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/certs.html b/base/tps-tomcat/shared/webapps/tps/ui/certs.html
index e694ac3fc185cd921f8d772c74271721e2c59bda..f15d9feca49ba773974657a73340c3ce94b6697d 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/certs.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/certs.html
@@ -60,20 +60,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="10">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/connection.html b/base/tps-tomcat/shared/webapps/tps/ui/connection.html
index 055ef21a22360f25c4f67fcf08bded90d160448f..8c24cc72a011edcbd3a7be490156accb0e6ffa05 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/connection.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/connection.html
@@ -77,20 +77,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="3">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/connections.html b/base/tps-tomcat/shared/webapps/tps/ui/connections.html
index 636cc4244bfe13371febf4c3ead271e33325a2ef..8b8c167191f13101ded6cb9fdac43020023d6663 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/connections.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/connections.html
@@ -48,20 +48,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="3">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/groups.html b/base/tps-tomcat/shared/webapps/tps/ui/groups.html
index bb481a8d5ebf1d8877cde9414f531fea1291496f..6a8b0192bbd29713bcfc4491acee2317daaf89e1 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/groups.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/groups.html
@@ -48,20 +48,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="3">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/profile.html b/base/tps-tomcat/shared/webapps/tps/ui/profile.html
index 337c9f102c44dc109161aa011c2e82651fb2a805..51f9bf6c0b1b205da95631ddde51c8deb76f393c 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/profile.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/profile.html
@@ -77,20 +77,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="3">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/profiles.html b/base/tps-tomcat/shared/webapps/tps/ui/profiles.html
index ca36f3ce503607980f144f7217e416896a85ac00..99b7ac759741b134b1a411e6160770f9bec0c56a 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/profiles.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/profiles.html
@@ -48,20 +48,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="3">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/selftests.html b/base/tps-tomcat/shared/webapps/tps/ui/selftests.html
index d2b4e2b9f0e5247bfecd27b0a31bf5d7dc224551..f9a7bdd45f013fced5a142d9b16ad3055a852903 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/selftests.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/selftests.html
@@ -52,20 +52,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="6">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/tokens.html b/base/tps-tomcat/shared/webapps/tps/ui/tokens.html
index 61c46b358e5aed84a4393aecc72cb1cab24b79dd..16ab6b235d5ce4d41a5bc8ded2205d1aaa22c9dd 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/tokens.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/tokens.html
@@ -60,20 +60,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="9">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
diff --git a/base/tps-tomcat/shared/webapps/tps/ui/users.html b/base/tps-tomcat/shared/webapps/tps/ui/users.html
index 54e6947aee9ce5f2c94fcf8759263555fb6efe27..89ef686e261de14ee467bb7b38e1d98e367337b0 100644
--- a/base/tps-tomcat/shared/webapps/tps/ui/users.html
+++ b/base/tps-tomcat/shared/webapps/tps/ui/users.html
@@ -48,20 +48,22 @@
 <tfoot>
     <tr>
          <th class="pki-table-actions" colspan="3">
-             <span name="info">
+             <div class="pki-table-info">
                  Total: <span name="totalEntries">0</span> entries
-             </span>
-             <span name="page-controls">
+             </div>
+             <div class="pki-page-controls">
                  <ul class="pagination">
                      <li><a href="#" name="first"><span class="i fa fa-angle-double-left"></span></a></li>
                      <li><a href="#" name="prev"><span class="i fa fa-angle-left"></span></a></li>
+                 </ul>
+                 <span class="pki-page-jump">
+                     <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
+                 </span>
+                 <ul class="pagination">
                      <li><a href="#" name="next"><span class="i fa fa-angle-right"></span></a></li>
                      <li><a href="#" name="last"><span class="i fa fa-angle-double-right"></span></a></li>
                  </ul>
-             </span>
-             <span name="page-jump">
-                 Page <input name="page" type="text" value="1"> of <span name="totalPages">1</span>
-             </span>
+             </div>
          </th>
     </tr>
 </tfoot>
-- 
1.8.4.2